SystemOrganization addCategory: #'Glamour-Tests-Morphic'!

TestCase subclass: #GLMMorphicTest
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

GLMMorphicTest subclass: #GLMAccumulatorMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMAccumulatorMorphicTest methodsFor: 'private' stamp: ''!
tabGroup
	^ self find: TabGroupMorph in: window! !

!GLMAccumulatorMorphicTest methodsFor: 'tests' stamp: ''!
testActiveEntity
	| browser |
	browser := GLMAccumulator new.
	browser show: [ :a | a list display: [ :x | $a to: x ] ].
	browser entity: $d.
	browser entity: $e.
	window := browser openOn: $d.
	browser entity: $c.
	self tabGroup selectedPageIndex: 1.
	self tabGroup update: #selectedIndex.
	self assert: browser activeEntity equals: $d! !

!GLMAccumulatorMorphicTest methodsFor: 'tests' stamp: ''!
testCloseTab
	| browser |
	browser := GLMAccumulator new.
	browser
		show: [ :a | 
			a title: [ :x | x asString ].
			a list display: [ :x | $a to: x ] ].
	window := browser openOn: $d.
	browser entity: $c.
	self assert: browser panes size equals: 2.
	self assert: self tabGroup pageMorphs size equals: 2.
	self tabGroup removePageIndex: 1.
	self assert: self tabGroup pageMorphs size equals: 1.
	self assert: browser panes size equals: 1! !

!GLMAccumulatorMorphicTest methodsFor: 'tests' stamp: ''!
testCreation
	| browser |
	browser := GLMAccumulator new.
	browser show: [ :a | a list display: [ :x | $a to: x ] ].
	window := browser openOn: $d.
	self find: LazyTabGroupMorph in: window! !

!GLMAccumulatorMorphicTest methodsFor: 'tests' stamp: ''!
testListInside
	| browser firstTreeMorph |
	browser := GLMAccumulator new.
	browser show: [ :a | a list display: [ :x | $a to: x ] ].
	window := browser openOn: $d.
	firstTreeMorph := self find: MorphTreeMorph  in: (self tabGroup pageAt: 1).
	self assert: ((firstTreeMorph roots collect: #complexContents) collect: #item) equals: ($a to: $d) asArray! !

!GLMAccumulatorMorphicTest methodsFor: 'tests' stamp: ''!
testPaneCreation
	| browser |
	browser := GLMAccumulator new.
	browser show: [ :a | a list display: [ :x | $a to: x ] ].
	window := browser openOn: $d.
	self assert: self tabGroup pages size equals: 1.
	browser entity: $c.
	self assert: self tabGroup pages size equals: 2! !

!GLMAccumulatorMorphicTest methodsFor: 'tests' stamp: ''!
testPaneRemoval
	| browser |
	browser := GLMAccumulator new.
	browser show: [ :a | a list display: [ :x | $a to: x ] ].
	window := browser openOn: $d.
	self assert: browser activeEntity = $d.	
	browser entity: $c.
	self assert: browser activeEntity = $c.
	self tabGroup removePageIndex: 1.
	self assert: self tabGroup tabSelectorMorph tabs size = 1.
	self assert: browser activeEntity = $c.
	self tabGroup removePageIndex: 1.
	self assert: self tabGroup tabSelectorMorph tabs isEmpty.
	self assert: browser activeEntity isNil.
	browser entity: $c.
	self assert: self tabGroup tabSelectorMorph tabs size = 1.! !

!GLMAccumulatorMorphicTest methodsFor: 'tests' stamp: ''!
testSelectedTab
	| browser |
	browser := GLMAccumulator new.
	browser
		show: [ :a | 
			a title: [ :x | x asString ].
			a list display: [ :x | $a to: x ] ].
	window := browser openOn: $d.
	self assert: self tabGroup selectedPageIndex equals: 1.
	browser entity: $c.
	self assert: self tabGroup selectedPageIndex equals: 2.
	browser entity: $d.
	self assert: self tabGroup selectedPageIndex equals: 1! !

!GLMAccumulatorMorphicTest methodsFor: 'tests' stamp: ''!
testTabTitle
	| browser firstTabLabel |
	browser := GLMAccumulator new.
	browser
		show: [ :a | 
			a title: [ :x | x asString ].
			a list display: [ :x | $a to: x ] ].
	window := browser openOn: $d.
	firstTabLabel := self find: PanelMorph in: self tabGroup tabSelectorMorph.
	self assert: firstTabLabel submorphs size equals: 2.
	self assert: firstTabLabel submorphs first contents equals: 'd'.
	self find: MultistateButtonMorph in: firstTabLabel.! !

GLMMorphicTest subclass: #GLMCompositePresentationAsStartMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMCompositePresentationAsStartMorphicTest methodsFor: 'tests' stamp: ''!
testSimpleOpen
	| p |
	p := GLMCompositePresentation new.
	p tabulator with: [:b | b row: #one. b transmit to: #one; andShow: [:a | a text ] ].
	window := p openOn: 42.
	self assert: (window isKindOf: GLMSystemWindow)! !

GLMMorphicTest subclass: #GLMCompositePresentationMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMCompositePresentationMorphicTest methodsFor: 'private' stamp: ''!
compositeMorph
	^ window submorphs last submorphs last submorphs last! !

!GLMCompositePresentationMorphicTest methodsFor: 'private' stamp: ''!
compositePanel
	|composite|
	composite := self compositeMorph.
	self assert: (composite isKindOf: PanelMorph).
	self assert: (composite submorphs allSatisfy: [:morph | morph isKindOf: ExpanderMorph]).
	^ composite
! !

!GLMCompositePresentationMorphicTest methodsFor: 'private' stamp: ''!
compositeTabGroup
	|composite|
	composite := self compositeMorph.
	self assert: (composite isKindOf: LazyTabGroupMorph).
	^ composite
! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: ''!
testAccordion
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					a accordionArrangement.
					a list title: 'List'.
					a text title: 'Text' ].
	window := browser openOn: 42.
	self assert: self compositePanel submorphs notEmpty.
	self assert: self compositePanel submorphs size equals: 2.
	self assert: self compositePanel submorphs first class equals: ExpanderMorph.
	self assert: self compositePanel submorphs last class equals: ExpanderMorph! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: ''!
testAccordionExpanded
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a accordionArrangement.
		a list title: 'List'.
		a text title: 'Text'].
	window := browser openOn: 42.
	self assert: self compositePanel submorphs first expanded.
	self assert: self compositePanel submorphs last expanded not.! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: ''!
testAccordionWithTitle
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					a accordionArrangement.
					a title: 'title'.
					a list.
					a text ].
	window := browser openOn: 42.
	self assert: self compositeTabGroup submorphs notEmpty.
	self assert: self compositeTabGroup submorphs size equals: 2.
	self assert: self compositeTabGroup contentMorph class equals: PanelMorph.
	self assert: self compositeTabGroup contentMorph submorphs first submorphs size equals: 2.
	self assert: self compositeTabGroup contentMorph submorphs first submorphs first class equals: ExpanderMorph! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: ''!
testFinder
	| finder |
	finder := GLMFinder new.
	finder
		show: [ :a | 
			a title: 'something'.
			a stackedArrangement.
			a list.
			a text ].
	self assert: finder presentations size equals: 2.
	self assert: (finder presentations arrangement isKindOf: GLMStackedVerticallyArrangement).
	window := finder openOn: (1 to: 42).
	self find: LazyTabGroupMorph in: window.! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: ''!
testOneStackedVerticallyWithTitle
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					a stackedVerticallyArrangement.
					a title: 'title'.
					a list ].
	window := browser openOn: 42.
	self assert: self compositeTabGroup submorphs notEmpty.
	self assert: self compositeTabGroup submorphs size equals: 2.
	self assert: self compositeTabGroup contentMorph class equals: PanelMorph.
	self assert: self compositeTabGroup contentMorph submorphs size equals: 1.
	self assert: self compositeTabGroup contentMorph submorphs first class equals: PanelMorph.
	self assert: self compositeTabGroup contentMorph submorphs first submorphs size equals: 1.
	self assert: self compositeTabGroup contentMorph submorphs first submorphs first class equals: LazyTabGroupMorph! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: ''!
testOneTabWithActions
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | a list act: #inspect entitled: 'Inspect' ].
	window := browser openOn: 42.
	self assert: self compositeMorph class equals: PanelMorph.
	self assert: self compositeMorph submorphs size equals: 2! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: ''!
testStackedVertically
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					a stackedVerticallyArrangement.
					a list title: 'list'.
					a text title: 'text' ].
	window := browser openOn: 42.
	self assert: self compositeMorph class equals: PanelMorph.
	self assert: self compositeMorph submorphs size equals: 2.
	self assert: self compositeMorph submorphs size equals: 2.
	self assert: self compositeMorph submorphs first class equals: LazyTabGroupMorph! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: ''!
testStackedVerticallyWithTitle
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					a stackedVerticallyArrangement.
					a title: 'title'.
					a list title: 'list'.
					a text title: 'text' ].
	window := browser openOn: 42.
	self assert: self compositeTabGroup submorphs notEmpty.
	self assert: self compositeTabGroup submorphs size equals: 2.
	self assert: self compositeTabGroup contentMorph class equals: PanelMorph.
	self assert: self compositeTabGroup contentMorph submorphs size equals: 1.
	self assert: self compositeTabGroup contentMorph submorphs first class equals: PanelMorph.
	self assert: self compositeTabGroup contentMorph submorphs first submorphs size equals: 2.
	self assert: self compositeTabGroup contentMorph submorphs first submorphs first class equals: LazyTabGroupMorph! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: ''!
testTabs
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					a list.
					a text ].
	window := browser openOn: 42.
	self assert: self compositeTabGroup pages size equals: 2! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: ''!
testTabsLastActivePresentation
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					a list.
					a text ].
	window := browser openOn: 42.
	self compositeTabGroup selectedPageIndex: 2.
	self assert: browser panes first lastActivePresentation notNil.
	self assert: (browser panes first lastActivePresentation isKindOf: GLMTextPresentation)! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: ''!
testTabsWithActions
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					a list act: #inspect entitled: 'Inspect'.
					a text ].
	window := browser openOn: 42.
	self assert: self compositeTabGroup toolbarMorph submorphs notEmpty.
	self compositeTabGroup selectedPageIndex: 2.
	self assert: self compositeTabGroup toolbarMorph submorphs isEmpty.
	self compositeTabGroup selectedPageIndex: 1.
	self assert: self compositeTabGroup toolbarMorph submorphs notEmpty! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: ''!
testTabsWithTitle
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					a title: 'title'.
					a list.
					a text ].
	window := browser openOn: 42.
	self assert: self compositeTabGroup submorphs size equals: 2.
	self assert: self compositeTabGroup submorphs first class equals: PanelMorph.
	self assert: self compositeTabGroup submorphs first submorphs size equals: 1.
	self assert: self compositeTabGroup submorphs first submorphs first class equals: LazyTabGroupMorph.
	self assert: self compositeTabGroup submorphs first submorphs first pages size equals: 2! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: ''!
testTabsWithTitleIconWithoutTitle
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					a titleIcon: GLMUIThemeExtraIcons glamorousBrowse.
					a list.
					a text ].
	window := browser openOn: 42.
	self assert: self compositeTabGroup submorphs size equals: 2.
	self assert: self compositeTabGroup submorphs first class equals: PanelMorph.
	self assert: self compositeTabGroup submorphs first submorphs size equals: 1.
	self assert: self compositeTabGroup submorphs first submorphs first class equals: LazyTabGroupMorph.
	self assert: self compositeTabGroup submorphs first submorphs first pages size equals: 2! !

!GLMCompositePresentationMorphicTest methodsFor: 'tests' stamp: ''!
testTabsWithUpdate
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					a list.
					a text ].
	window := browser openOn: 42.
	self assert: self compositeTabGroup pages size equals: 2.
	self shouldnt: [browser panes first presentations update]  raise: Error! !

GLMMorphicTest subclass: #GLMDashboardMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMDashboardMorphicTest methodsFor: 'tests' stamp: ''!
testPanesExtent
	
	| dashboard  mainCell firstColumn secondColumn|
	dashboard := GLMDashboard.
	dashboard := GLMDashboard new. 
	dashboard rigidStrategy.
	dashboard addPaneNamed: #one extent: 20@45.
	dashboard addPaneNamed: #two extent: 50@10.
	dashboard addPaneNamed: #three extent: 20@40.
	dashboard addPaneNamed: #four.
	
	window := dashboard openOn: #start.
	mainCell := window submorphs last submorphs last submorphs last. 
	firstColumn := mainCell submorphs first.
	secondColumn := mainCell submorphs second.	
	self assert: firstColumn submorphs first extent = (20@45).
	self assert: firstColumn submorphs second extent = (50@10).
	self assert: secondColumn submorphs first extent = (20@40).
	"self assert: secondColumn submorphs second extent = dashboard defaultPaneExtent "
	! !

!GLMDashboardMorphicTest methodsFor: 'tests' stamp: ''!
testPanesExtentWithFillWidthStrategy
	
	| dashboard  mainCell firstColumn secondColumn|
	dashboard := GLMDashboard.
	dashboard := GLMDashboard new. 
	dashboard fillWidthStrategy.
	dashboard addPaneNamed: #one extent: 20@45.
	dashboard addPaneNamed: #two extent: 50@10.
	dashboard addPaneNamed: #three extent: 20@40.
	dashboard addPaneNamed: #four.
	
	window := dashboard openOn: #start.
	mainCell := window submorphs last submorphs last submorphs last. 
	firstColumn := mainCell submorphs first.
	secondColumn := mainCell submorphs second.	
	self deny: firstColumn submorphs first extent = (20@45).
	self assert: firstColumn submorphs first extent y = 45.
	self deny: firstColumn submorphs second extent = (50@10).
	self assert: firstColumn submorphs second extent y = 10.
	self deny: secondColumn submorphs first extent = (20@40).
	self assert: secondColumn submorphs first extent y = 40.
	"self deny: secondColumn submorphs second extent = dashboard defaultPaneExtent."
	"self assert: secondColumn submorphs second extent  y = dashboard defaultPaneExtent y  "
	! !

GLMMorphicTest subclass: #GLMDropDownMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMDropDownMorphicTest methodsFor: 'as yet unclassified' stamp: ''!
testSelectionTriggeredOnSelectedIndex
	| browser dropdown text dropdownMorph textMorph |
	browser := GLMTabulator new.
 	browser row: #one; row: #two.
 	browser transmit to: #one; andShow: [:a |
 		a dropDownList
 			display: [:x | (1 to: x) + 10 ];
 			selectedIndex: 2 ].
 	browser transmit from: #one; to: #two; andShow: [:a |
 		a text].
 	window := browser openOn: 5.
	dropdown := browser panes first presentations first.
	"Because #selectedIndex: must trigger a transmission, we should get the text presentation in #two"
	self assert: browser panes second presentations size equals: 1.
	text := browser panes second presentations first.
	dropdownMorph := self findWherePresentationIs: dropdown in: window.
	textMorph := self findWherePresentationIs: text in: window.
	self assert: dropdownMorph selectedItem contents equals: '12'.
	self assert: textMorph text asString equals: '12'! !

GLMMorphicTest subclass: #GLMDynamicMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMDynamicMorphicTest methodsFor: 'tests' stamp: ''!
expectedFailures 
	^ #(testWithDisplay)! !

!GLMDynamicMorphicTest methodsFor: 'tests' stamp: ''!
testSurroundingPanel
	| browser dynamicContainerMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | a dynamic presentation: [:some :object | some text ]].
	window := browser openOn: 4.

	dynamicContainerMorph := window submorphs last submorphs first submorphs first.
	self assert: (dynamicContainerMorph isKindOf: PanelMorph).
	self assert: (dynamicContainerMorph submorphs first isKindOf: PluggableTextMorph)! !

!GLMDynamicMorphicTest methodsFor: 'tests' stamp: ''!
testUpdate
	| browser dynamicContainerMorph presentationObject |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a dynamic presentation: [:some :object | 
			some custom: presentationObject ]].
	presentationObject := GLMTextPresentation new.
	window := browser openOn: 42.
	dynamicContainerMorph := window submorphs last submorphs first submorphs first.
	self assert: (dynamicContainerMorph isKindOf: PanelMorph).
	self assert: (dynamicContainerMorph submorphs first isKindOf: PluggableTextMorph).
	presentationObject := GLMListPresentation new.
	browser update.
	dynamicContainerMorph := window submorphs last submorphs first submorphs first.
	self assert: (dynamicContainerMorph isKindOf: PanelMorph).
	self assert: (dynamicContainerMorph submorphs first submorphs first isKindOf: MorphTreeMorph)! !

!GLMDynamicMorphicTest methodsFor: 'tests' stamp: ''!
testWithDisplay
	| browser dynamic stacker text textMorph |
	browser := GLMTabulator new column: #stacker; yourself.
	browser transmit to: #stacker; andShow: [:c | 
		c dynamic
			display: [:number | |st|
				st := GLMStacker new.
				st aPane: #all.
				st transmit to: #all; andShow: [:a | a text display: ['All ', number asString]].
				st]].
	window := browser openOn: 10.
	dynamic := browser panes first presentations first.
	stacker := dynamic cachedPresentation first.
	self assert: stacker panes first presentations size equals: 1.
	text := stacker panes first presentations first.
	textMorph := self findWherePresentationIs: text in: window.
	self assert: textMorph text asString equals: 'All 10'
	! !

!GLMDynamicMorphicTest methodsFor: 'tests' stamp: ''!
testWithPresentation
	| browser dynamic text textMorph |
	browser := GLMTabulator new column: #stacker; yourself.
	browser transmit to: #stacker; andShow: [:c | 
		c dynamic
			presentation: [:presentation :number |
					presentation text display: ['All ', number asString]]].
	window := browser openOn: 10.
	dynamic := browser panes first presentations first.
	text := dynamic cachedPresentation first.
	textMorph := self findWherePresentationIs: text in: window.
	self assert: textMorph text asString equals: 'All 10'! !

GLMMorphicTest subclass: #GLMExpanderMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMExpanderMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 3/21/2012 21:55'!
testCreation
	| browser |
	browser := GLMExpander new.
	browser show: [ :a | a text ].
	window := browser openOn: #(#a #b #c).
	self assert: window submorphs last class equals: GeneralScrollPane.
	self assert: window submorphs last scrollTarget submorphs size equals: 3.
	self assert: window submorphs last scrollTarget submorphs first complexContents class equals: ExpanderMorph! !

GLMMorphicTest subclass: #GLMFinderMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMFinderMorphicTest methodsFor: 'tests' stamp: ''!
testClose
	| finder |
	finder := GLMFinder new.
	window := finder openOn: 123.
	self assert: window owner notNil.
	finder close.
	self assert: window owner isNil! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: ''!
testCreationVariableSize
	window := (GLMFinder new)
		variableSizePanes;
		openOn: 123.
	self assert: window submorphs last class equals: GeneralScrollPane! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: ''!
testDefaultFixedSizePanes
	| finder container |
	finder := GLMFinder new.
	window := finder openOn: 40.
	window width: 501.
	container := self find: TransformMorph in: window.
	self assert: container submorphs first width equals: window submorphs last width.
	(finder panes first port: #selection) value: 42.
	self assert: container submorphs size equals: 3.
	self
		assert: container submorphs first extent
		equals: container submorphs last extent.
	self assert: container submorphs first width <= (window submorphs last width / 2)! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: ''!
testEmbeddedBrowserRefreshesRendering
	| tabulator finder tabulator1 textMorph1 textMorph2 content1 details1 |
	"self debug: #testEmbeddedBrowserRefreshesRendering"
	tabulator := GLMTabulator new.
	tabulator
		row: #content;
		row: #details.
	(tabulator transmit)
		to: #content;
		andShow: [ :a | a list display: [ :x | 1 to: x ] ].
	(tabulator transmit)
		from: #content;
		to: #details;
		andShow: [ :a | a text ].
	(tabulator transmit)
		from: #content;
		toOutsidePort: #selection.
	finder := GLMFinder new.
	finder show: [ :a | a custom: tabulator ].
	window := finder openOn: 42.
	
	tabulator1 := finder panes first presentations first.
	content1 := tabulator1 panes first.
	details1 := tabulator1 panes second.
	(content1 port: #selection) value: 41.
	textMorph1 := self findWherePresentationIs: details1 presentations first in: window.
	self assert: textMorph1 model text = '41'.
	
	(content1 port: #selection) value: 42.
	self assert: tabulator1 ==  finder panes first presentations first.
	self assert: details1 == tabulator1 panes second.
	self assert: details1 presentations first text asString equals: '42'.
	textMorph2 := self findWherePresentationIs: details1 presentations first in: window.
	self assert: textMorph2 model text asString equals: '42'! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: ''!
testFinderWithEmbeddedBrowser

	| navigator finder tree1 tree2 |
	navigator := GLMTabulator new.
	navigator row: #content; row: #details.
	navigator transmit to: #content; andShow: [:a | a list display: #allSuperclasses].
	navigator transmit from: #content; to: #details; andShow: [ :a | a text ].
	navigator transmit from: #content; toOutsidePort: #selection.
	finder := GLMFinder new.
	finder show: [:a | a custom: navigator].

	window := finder openOn: String.
	(finder panes first port: #selection) value: Collection.
	
	self assert: finder panes first presentations first ~= finder panes last presentations first.

	tree1 := self find: MorphTreeMorph in: window submorphs last submorphs last submorphs first.
	tree2 := self findLast: MorphTreeMorph in: window submorphs last submorphs last submorphs last.
	self assert: tree1 notNil.
	self assert: tree2 notNil.
	self assert: tree1 ~= tree2.
	self assert: tree1 model glamourPresentation pane ~= tree2 model glamourPresentation pane.
	self assert: tree1 model glamourPresentation ~= tree2 model glamourPresentation.! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: ''!
testFixedSize
	window := GLMFinder new openOn: 123.
	self assert: window submorphs last class equals: GLMPaneScroller! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: ''!
testMultiplePresentationsValidation
	| browser |
	browser := GLMFinder new.
	browser show: [:a | a list. a text ].
	window := browser openOn: ($a to: $d).
	(browser panes first port: #selection) value: $z.
	self assert: (browser panes first port: #selection) value equals: $z! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: ''!
testNoSelection
	| browser treeMorph treeNodeMorph |
	browser := GLMFinder new.
	browser show: [:a | a tree noSelection].
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self assert: browser panes size equals: 1! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: ''!
testOneFixedSizePane
	| finder |
	finder := GLMFinder new fixedSizePanes: 1.
	window := finder openOn: 40.
	self assert: window submorphs last submorphs first submorphs first width equals: window submorphs last width.
	(finder panes first port: #selection) value: 42.
	self assert: window submorphs last submorphs last submorphs size equals: 3.
	self
		assert: window submorphs last submorphs last submorphs first extent
		equals: window submorphs last submorphs last submorphs last extent.
	self assert: window submorphs last submorphs last submorphs first width equals: window submorphs last width! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: ''!
testRemovingVariableSizePanes
	| finder |
	finder := GLMFinder new variableSizePanes.
	window := finder openOn: 40.
	self assert: window submorphs last scrollTarget submorphs size equals: 2.
	(finder panes first port: #selection) value: 41.
	self assert: window submorphs last scrollTarget submorphs size equals: 4.
	(finder panes first port: #selection) value: 42.
	self assert: window submorphs last scrollTarget submorphs size equals: 4.
	(finder panes second port: #selection) value: 43.
	self assert: window submorphs last scrollTarget submorphs size equals: 6.
	(finder panes first port: #selection) value: 44.
	self assert: window submorphs last scrollTarget submorphs size equals: 4! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: ''!
testRemovingVariableSizePanesWhenChangingEntity
	| finder |
	finder := GLMFinder new variableSizePanes.
	window := finder openOn: #a.
	self assert: window submorphs last scrollTarget submorphs size equals: 2.
	finder entity: #b.
	self assert: window submorphs last scrollTarget submorphs size equals: 2! !

!GLMFinderMorphicTest methodsFor: 'tests' stamp: ''!
testSpawnFinder
	| browser |
	browser := GLMFinder new.
	window := browser openOn: ($a to: $d).
	self repeatAssert: [window submorphs last class] equals: GLMPaneScroller.
! !

GLMMorphicTest subclass: #GLMListMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMListMorphicTest methodsFor: 'tests' stamp: ''!
testListDoubleClick
	| browser treeMorph treeNodeMorph |
	browser := GLMFinder new.
	browser show: [ :a | a list ].
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self send: treeMorph mouseUpWithShift: false onItem: treeNodeMorph.
	self send: treeMorph doubleClickWithShift: false onItem: treeNodeMorph.
	self assert: (browser panes first port: #strongSelection) value equals: $a! !

!GLMListMorphicTest methodsFor: 'tests' stamp: ''!
testListDoubleClickWithMultipleSelection
	| browser treeMorph treeNodeMorph lastTreeNodeMorph |
	browser := GLMFinder new.
	browser show: [:a | a tree beMultiple].
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	lastTreeNodeMorph := treeMorph scroller submorphs last.
	self send: treeMorph mouseUpWithShift: false onItem: treeNodeMorph.
	self send: treeMorph mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self send: treeMorph doubleClickWithShift: false onItem: treeNodeMorph.
	self assert: (browser panes first port: #strongSelection) value asSet equals: ($a to: $d) asSet! !

!GLMListMorphicTest methodsFor: 'tests' stamp: ''!
testMultipleSelectionWithChange
	| browser firstTreeMorph secondTreeMorph treeNodeMorph lastTreeNodeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					(a list)
						beMultiple;
						display: [ :x | x - 2 to: x ] ].
	window := browser openOn: 4.
	firstTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	treeNodeMorph := firstTreeMorph scroller submorphs first.
	lastTreeNodeMorph := firstTreeMorph scroller submorphs last.
	self send: firstTreeMorph mouseUpOnItem: treeNodeMorph.
	self send: firstTreeMorph mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self
		assert: (firstTreeMorph model selection selectedNodePathList collect: [ :each | each first item ]) asOrderedCollection
		equals: #(2 3 4) asOrderedCollection.
	(browser pane port: #entity) value: 42.
	secondTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	treeNodeMorph := secondTreeMorph scroller submorphs first.
	lastTreeNodeMorph := secondTreeMorph scroller submorphs second.
	self send: secondTreeMorph mouseUpOnItem: treeNodeMorph.
	self send: secondTreeMorph mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self
		assert: (secondTreeMorph model selection selectedNodePathList collect: [ :each | each first item ]) asOrderedCollection
		equals: #(40 41) asOrderedCollection! !

!GLMListMorphicTest methodsFor: 'tests' stamp: ''!
testMultipleSelectionWithChangeFromModel
	| browser firstTreeMorph secondTreeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					(a list)
						beMultiple;
						display: [ :x | x - 2 to: x ] ].
	window := browser openOn: 4.
	firstTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	self assert: (firstTreeMorph model roots collect: #item) equals: #(2 3 4).
	((browser paneNamed: #one) port: #selection) value: #(2 3).
	self assert: ((browser paneNamed: #one) port: #selection) value asOrderedCollection equals: #(2 3) asOrderedCollection.
	(browser pane port: #entity) value: 42.
	secondTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	self assert: (secondTreeMorph model roots collect: #item) equals: #(40 41 42).
	((browser paneNamed: #one) port: #selection) value: #(40 41).
	self
		assert: ((browser paneNamed: #one) port: #selection) value asOrderedCollection
		equals: #(40 41) asOrderedCollection.
	self assert: firstTreeMorph ~= secondTreeMorph! !

!GLMListMorphicTest methodsFor: 'tests' stamp: ''!
testOnlyOneMorphPerRowInList
	| browser listMorph nodeMorphs|
	"self debug: #testOnlyOneMorphPerRowInList"
	browser := GLMTabulator new.
	browser
		column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | a list display: [ :x | x ] ].
	window := browser openOn: (1 to: 100).
	World doOneCycle.
	listMorph := self find: MorphTreeMorph in: window.
	nodeMorphs := (self find: MorphTreeTransformMorph in: listMorph) submorphs.
	self assert: nodeMorphs size equals: 100.
	nodeMorphs do: [:node | "Always fails on node 43" self assert: node submorphs size equals: 1].! !

!GLMListMorphicTest methodsFor: 'tests' stamp: ''!
testTextBackgroundColor
	| browser firstTreeMorph secondTreeMorph treeNodeMorph txtMorph |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					(a list)
						display: [ :x | 1 to: x];
						textBackgroundColor: [:aNumber | (aNumber isDivisibleBy: 2)
							ifTrue: [Color green]
							ifFalse: [Color red]
							 ]. ].
						
	window := browser openOn: 4.
	firstTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	treeNodeMorph := firstTreeMorph scroller submorphs first.
	txtMorph := treeNodeMorph submorphs first submorphs first submorphs first.
	self assert: (txtMorph isKindOf: TextMorph).
	self assert: txtMorph backgroundColor = Color red.
	
	treeNodeMorph := firstTreeMorph scroller submorphs second.
	txtMorph := treeNodeMorph submorphs first submorphs first submorphs first.
	self assert: (txtMorph isKindOf: TextMorph).
	self assert: txtMorph backgroundColor = Color green.
	
	treeNodeMorph := firstTreeMorph scroller submorphs third.
	txtMorph := treeNodeMorph submorphs first submorphs first submorphs first.
	self assert: (txtMorph isKindOf: TextMorph).
	self assert: txtMorph backgroundColor = Color red.
	
	treeNodeMorph := firstTreeMorph scroller submorphs fourth.
	txtMorph := treeNodeMorph submorphs first submorphs first submorphs first.
	self assert: (txtMorph isKindOf: TextMorph).
	self assert: txtMorph backgroundColor = Color green.
	! !

!GLMListMorphicTest methodsFor: 'tests' stamp: ''!
testTwoPanesMultipleSelectionWithChange
	| browser treeMorphOne treeNodeMorph treeMorphTwo |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two;
		column: #three.
	(browser transmit)
		to: #one;
		andShow: [ :a | a list display: [ :x | 1 to: x ] ].
	(browser transmit)
		to: #two;
		from: #one;
		andShow: [ :a | 
					(a list)
						beMultiple;
						display: [ :x | x * 10 to: x * 10 + 4 ] ].
	(browser transmit)
		to: #three;
		from: #two;
		andShow: [ :a | a text ].
	window := browser openOn: 4.	"we select 2 in the first pane"
	treeMorphOne := (window submorphs last submorphs at: 3) submorphs first submorphs first.
	treeNodeMorph := treeMorphOne scroller submorphs second.
	self send: treeMorphOne mouseUpOnItem: treeNodeMorph.	"we select all in the second pane"
	treeMorphTwo := (window submorphs last submorphs at: 4) submorphs first submorphs first.
	treeNodeMorph := treeMorphTwo scroller submorphs first.
	self send: treeMorphTwo mouseUpOnItem: treeNodeMorph.
	treeNodeMorph := treeMorphTwo scroller submorphs second.
	self send: treeMorphTwo mouseUpWithShift: true onItem: treeNodeMorph.
	self assert: ((browser paneNamed: #two) port: #selection) value asOrderedCollection equals: #(20 21) asOrderedCollection.	"we select 4 in the first pane"
	treeMorphOne := (window submorphs last submorphs at: 3) submorphs first submorphs first.
	treeNodeMorph := treeMorphOne scroller submorphs last.
	self send: treeMorphOne mouseUpOnItem: treeNodeMorph.	"we select the first two in the second pane"
	treeMorphTwo := (window submorphs last submorphs at: 4) submorphs first submorphs first.
	self assert: (treeMorphTwo model roots collect: #item) equals: #(40 41 42 43 44).
	treeNodeMorph := treeMorphTwo scroller submorphs first.
	self send: treeMorphTwo mouseUpOnItem: treeNodeMorph.
	treeNodeMorph := treeMorphTwo scroller submorphs second.
	self send: treeMorphTwo mouseUpWithShift: true onItem: treeNodeMorph.
	self assert: ((browser paneNamed: #two) port: #selection) value asOrderedCollection equals: #(40 41) asOrderedCollection! !

!GLMListMorphicTest methodsFor: 'tests' stamp: ''!
testUpdateFromModel
	| browser treeMorphOne1 treeMorphTwo1 treeMorphOne2 treeMorphTwo2 |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two.
	(browser transmit)
		to: #one;
		andShow: [ :a | a list display: [ :x | x - 3 to: x ] ].
	(browser transmit)
		to: #two;
		from: #one;
		andShow: [ :a | a list display: [ :x | x * 10 to: x * 10 + 2 ] ].
	window := browser openOn: 4.
	treeMorphOne1 := self find: MorphTreeMorph in: window.
	self assert: (treeMorphOne1 model roots collect: #item) equals: #(1 2 3 4).
	((browser paneNamed: #one) port: #selection) value: 2.
	treeMorphTwo1 := self findLast: MorphTreeMorph in: window.
	self assert: (treeMorphTwo1 model roots collect: #item) equals: #(20 21 22).
	browser entity: 8.
	treeMorphOne2 := self find: MorphTreeMorph in: window.
	self assert: (treeMorphOne2 model roots collect: #item) equals: #(5 6 7 8).
	self assert: treeMorphOne1 ~= treeMorphOne2.
	self assert: window submorphs last submorphs last submorphs first submorphs isEmpty.
	((browser paneNamed: #one) port: #selection) value: 5.
	treeMorphTwo2 := self findLast: MorphTreeMorph in: window.
	self assert: (treeMorphTwo2 model roots collect: #item) equals: #(50 51 52).
	self assert: treeMorphTwo1 ~= treeMorphTwo2! !

GLMMorphicTest subclass: #GLMMorphMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMMorphMorphicTest methodsFor: 'tests' stamp: ''!
testMorphUpdate
	| browser number originalMorph newMorph |
	
	number := 42.
	browser := GLMTabulator new.
	browser	row: #morph.
	browser transmit to: #morph; andShow: [ :presenter | 
		presenter morph 
			display: [ :x | number asString asMorph ] ].
	window := browser openOn: 42.
	
	originalMorph := self findLast: StringMorph in: window.
	self assert: originalMorph notNil.
	self assert: originalMorph contents = 42 asString.
	
	number := 43.
	browser update.
	
	newMorph := self findLast: StringMorph in: window.
	self assert: newMorph ~= originalMorph.
	self assert: newMorph notNil.
	self assert: newMorph notNil.
	self assert: newMorph contents = 43 asString.
	
	
	
	
		! !

!GLMMorphMorphicTest methodsFor: 'tests' stamp: ''!
testMorphUpdateOnAnnounce
	| browser number originalMorph newMorph announcer |
	
	announcer := GLMAnnouncer new. 
	number := 42.
	browser := GLMTabulator new.
	browser	row: #morph.
	browser transmit to: #morph; andShow: [ :presenter | 
		presenter morph 
			updateOn: Announcement from: [ announcer ];
			display: [ :x | number asString asMorph ] ].
	window := browser openOn: 42.
	
	originalMorph := self findLast: StringMorph in: window.
	self assert: originalMorph notNil.
	self assert: originalMorph contents = 42 asString.
	
	number := 43.
	announcer announce: Announcement.
	
	newMorph := self findLast: StringMorph in: window.
	self assert: newMorph ~= originalMorph.
	self assert: newMorph notNil.
	self assert: newMorph notNil.
	self assert: newMorph contents = 43 asString.
	
	
	
	
		! !

GLMMorphicTest subclass: #GLMMorphicExamplesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMMorphicExamplesTest methodsFor: 'tests' stamp: ''!
testSmoke
	GLMBasicExamples allExamples do: [:eachPragma | 
		| input browser |
		input := Compiler evaluate: (eachPragma argumentAt: 2) logged: false.
		browser := GLMBasicExamples new perform: eachPragma selector.
		[window := browser openOn: input]
			ensure: [window notNil ifTrue: [window delete] ] ]! !

!GLMMorphicTest methodsFor: 'private' stamp: ''!
find: aClass in: aMorph
	"Explores aMorph hierarchy of sub morphs to find a morph whose class inherits from aClass"
	^ self findSatisfying: [:morph | morph isKindOf: aClass ] in: aMorph  ! !

!GLMMorphicTest methodsFor: 'private' stamp: ''!
findLast: aClass in: aMorph
	"Explores aMorph hierarchy of sub morphs to find the last morph whose class inherits from aClass"
	^ self findLastSatisfying: [:morph | morph isKindOf: aClass ] in: aMorph  ! !

!GLMMorphicTest methodsFor: 'private' stamp: ''!
findLastSatisfying: aBlock in: aMorph
	"Explores aMorph hierarchy of sub morphs to find the last morph who satisfies aBlock"
	| lastMatch |
	lastMatch := nil. 
	aMorph allMorphsDo: [:each | (aBlock value: each) ifTrue: [lastMatch := each]].
	^ lastMatch ifNil: [self fail]! !

!GLMMorphicTest methodsFor: 'private' stamp: ''!
findSatisfying: aBlock in: aMorph
	"Explores aMorph hierarchy of sub morphs to find a morph who satisfies aBlock"
	aMorph allMorphsDo: [:each | (aBlock value: each) ifTrue: [^ each]].
	self fail.! !

!GLMMorphicTest methodsFor: 'private' stamp: ''!
findWherePresentationIs: aPresentation in: aMorph
	"Explores aMorph hierarchy of sub morphs to find a morph whose model is exactly aModel"
	^ self findSatisfying: 
				[:morph | morph model notNil 
					and: [(morph model respondsTo: #glamourPresentation) 
					and: [morph model glamourPresentation == aPresentation]] ]
			in: aMorph  ! !

!GLMMorphicTest methodsFor: 'private' stamp: ''!
repeatAssert: aBlock equals: aResult

	self assert: (self wait: 0.5 until: aBlock evaluatesTo: aResult)! !

!GLMMorphicTest methodsFor: 'private' stamp: ''!
send: treeMorph doubleClickWithShift: aBoolean onItem: treeNodeMorph
	| event |
	event:= MouseButtonEvent basicNew 
		setType: #mouseDown
		position: (treeNodeMorph bounds origin + (1@1))
		which: 4
		buttons: (aBoolean ifTrue: [8] ifFalse: [0])
		hand: (HandMorph new mouseFocus: treeNodeMorph; yourself)
		stamp: nil.
	treeMorph doubleClick: event! !

!GLMMorphicTest methodsFor: 'private' stamp: ''!
send: treeMorph mouseDownWithShift: aBoolean onItem: treeNodeMorph
	| mouseUp |
	mouseUp := MouseButtonEvent basicNew 
		setType: #mouseDown
		position: (treeNodeMorph bounds origin + (1@1))
		which: 4
		buttons: (aBoolean ifTrue: [8] ifFalse: [0])
		hand: (HandMorph new mouseFocus: treeNodeMorph; yourself)
		stamp: nil.
	treeMorph mouseUp: mouseUp onMorph: treeNodeMorph.! !

!GLMMorphicTest methodsFor: 'private' stamp: ''!
send: treeMorph mouseUpOnItem: treeNodeMorph
	^ self send: treeMorph mouseUpWithShift: false onItem: treeNodeMorph! !

!GLMMorphicTest methodsFor: 'private' stamp: ''!
send: treeMorph mouseUpWithShift: aBoolean onItem: treeNodeMorph
	| mouseUp |
	mouseUp := MouseButtonEvent basicNew 
		setType: #mouseUp
		position: (treeNodeMorph bounds origin + (1@1))
		which: 4
		buttons: (aBoolean ifTrue: [8] ifFalse: [0])
		hand: (HandMorph new mouseFocus: treeNodeMorph; yourself)
		stamp: nil.
	treeMorph listManager mouseUp: mouseUp on: treeNodeMorph.! !

!GLMMorphicTest methodsFor: 'setup - tear down' stamp: ''!
tearDown
	window ifNotNil: [window delete]! !

!GLMMorphicTest methodsFor: 'private' stamp: ''!
wait: maxWaitSeconds until: validateBlock evaluatesTo: expectedResult
	"Evaluate validateBlock until it returns expectedResult or 
maxWaitSeconds have passed,
	 pausing between evaluations.  Return the last result of validateBlock 
value"

	| startTime result |
	startTime := Time millisecondClockValue // 1000.
	[result := validateBlock value = expectedResult] whileFalse:
			[Time secondClock - startTime > maxWaitSeconds ifTrue: [^result].
			(Delay forMilliseconds: 50) wait].
	^ result
! !

GLMMorphicTest subclass: #GLMSmalltalkCodeMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMSmalltalkCodeMorphicTest methodsFor: 'tests' stamp: ''!
testDefault
	| browser textMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | a smalltalkCode display: '123456789'].
	window := browser openOn: 4.

	textMorph := window submorphs last submorphs first submorphs first.
	self assert: (textMorph isKindOf: GLMPluggableTextMorph)! !

!GLMSmalltalkCodeMorphicTest methodsFor: 'tests' stamp: ''!
testExplicitAcceptDoesNotAffectTextPort
	| browser textMorph textPresentation |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | a smalltalkCode display: '123' ].
	window := browser openOn: 4.
	textMorph := self find: GLMPluggableTextMorph in: window.
	textMorph simulateClick.
	self simulateKeyStrokes: '4'.
	self assert: (browser panes first port: #text) value = '1234'.
	self simulateKeyStroke: $s command.
	self simulateKeyStrokes: '56'.
	self assert: (browser panes first port: #text) value = '123456'! !

!GLMSmalltalkCodeMorphicTest methodsFor: 'tests' stamp: ''!
testForSmalltalkWorkspace
	| browser textMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | a smalltalkCode variableBindings: [:x | {#theNumber -> x}]].
	window := browser openOn: 42.

	textMorph := self find: GLMPluggableTextMorph in: window.
	self assert: (textMorph model hasBindingOf: #theNumber)! !

GLMMorphicTest subclass: #GLMTableMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMTableMorphicTest methodsFor: 'tests' stamp: ''!
testColumnBlockTakesEntity

	| browser receivedEntity |
	browser := GLMFinder new.
	receivedEntity := nil.
	browser show: [:a | a table
		column: 'Even' evaluated: [:each :entity | receivedEntity := entity. 'x']].
	window := browser openOn: (1 to: 5).
	World doOneCycle.
	self repeatAssert: [receivedEntity] equals: (1 to: 5).
! !

!GLMTableMorphicTest methodsFor: 'tests' stamp: ''!
testColumnLabel
	| browser tableMorph |
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					(a table)
						display: [ :x | x - 3 to: x ];
						column: 'Column' evaluated: [ :x | x asString ];
						column: [ :x | 'Number ' , x asString ] evaluated: #asString ].
	window := browser openOn: 4.
	tableMorph := self find: MorphTreeMorph in: window.
	self assert: (tableMorph model roots collect: #item) equals: #(1 2 3 4).
	self assert: tableMorph columns first header label equals: 'Column'.
	self assert: tableMorph columns last header label equals: 'Number 4'! !

GLMMorphicTest subclass: #GLMTabulatorMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMTabulatorMorphicTest methodsFor: 'tests' stamp: ''!
testMultipleInitialSelection
	| browser firstTreeMorph secondTreeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser
		transmit to: #one;
		andShow: [ :a | 
					(a tree)
						beMultiple;
						display: [ :x | 1 to: x * 3 ] ].
	window := browser openOn: 5.
	(browser panes first port: #selection) value: #(2 5 3).
	firstTreeMorph := self find: MorphTreeMorph in: window.
	self assert: firstTreeMorph model selection notNil.
	self assert: firstTreeMorph model selection selectedItemOrItemsOrNil size equals: 3.! !

!GLMTabulatorMorphicTest methodsFor: 'tests' stamp: ''!
testSpawnTabulator

	| browser |
	browser := GLMTabulator new.
	window := browser openOn: ($a to: $d).
	self assert: window model == browser.
	self repeatAssert: [
		window submorphs last 
					submorphs last 
						submorphs last 
							submorphs last class] equals: PaginatedMorphTreeMorph
! !

!GLMTabulatorMorphicTest methodsFor: 'tests' stamp: ''!
testStatusbar
	| browser statusMorph |
	browser := GLMTabulator new.
	browser addStatusbar.
	browser row: #one.
	browser transmit to: #one; andShow: [:a | a list display: #(1 2 3)].
	window := browser openOn: 42.
	((browser paneNamed: #one) port: #status) value: 2.
	World doOneCycle.
	statusMorph := (window submorphs last: 2) first submorphs first.	
	self assert: (statusMorph isKindOf: LabelMorph)! !

GLMMorphicTest subclass: #GLMTextMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMTextMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2012 08:53'!
testExplicitAcceptDoesNotAffectTextPort
	| composite textMorph textPresentation |
	composite := GLMCompositePresentation new with: [ :a | a text display: '123' ].
	window := composite openOn: 4.
	textMorph := self find: PluggableTextMorph in: window.
	textMorph simulateClick.
	self simulateKeyStrokes: '4'.
	self assert: (composite pane port: #text) value = '1234'.
	self simulateKeyStroke: $s command.
	self simulateKeyStrokes: '56'.
	self assert: (composite pane port: #text) value = '123456'! !

!GLMTextMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2012 08:52'!
testMultipleSelectionWithChange
	| composite textMorph textPresentation |
	composite := GLMCompositePresentation new with: [ :a | a text display: '123456789' ].
	window := composite openOn: 4.
	textMorph := self find: PluggableTextMorph in: window.
	self assert: textMorph selectionInterval isEmpty.
	textPresentation := composite presentations first.
	textPresentation selectionInterval: (2 to: 5).
	self assert: textMorph selectedContents asString equals: '2345'.
	self assert: textPresentation selectedText asString equals: '2345'! !

!GLMTextMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2012 08:49'!
testPastingUpdatesTextPort
	| composite textMorph textPresentation |
	composite := GLMCompositePresentation new with: [:a | a text display: '' ].
	window := composite openOn: 42.
	textMorph := self find: PluggableTextMorph in: window.

	Clipboard clipboardText: '42'.
	textMorph simulateClick.
	self simulateKeyStroke: $v command.
	self assert: (composite pane port: #text) value = '42'! !

!GLMTextMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2012 11:13'!
testTextPortPopulatedByDefault
	| composite |
	composite := GLMCompositePresentation new with: [:a | a text ].
	window := composite openOn: '42'.
	self assert: (composite pane port: #text) value asString equals: '42'! !

!GLMTextMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 7/29/2012 08:53'!
testUnregisterFromAnnouncementsWhenUpdating
	| composite announcingCollection numberOfExecutions |
	numberOfExecutions := 0.
	announcingCollection := GLMAnnouncingCollection new.
	composite :=  GLMCompositePresentation new with: [ :a | 
					(a text)
						updateOn: GLMItemAdded from: [ announcingCollection ];
						display: [ numberOfExecutions := numberOfExecutions + 1 ] ].
	window := composite openOn: announcingCollection.
	1 to: 3 do: [ :each | announcingCollection add: each ].
	self assert: numberOfExecutions equals: 4	"it should not be 8"! !

GLMMorphicTest subclass: #GLMTreeMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMTreeMorphicTest methodsFor: 'tests' stamp: ''!
testChildrenBlock
	| browser check |
	browser := GLMFinder new.
	check := false.
	browser show: [:a | a tree
		children: [ :each | 
			check := true.
			#() ]].
	window := browser openOn: ($a to: $d).
	World doOneCycle.
	self repeatAssert: [ check ] equals: true! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: ''!
testChildrenBlockTakesEntity
	| browser receivedEntity |
	browser := GLMFinder new.
	receivedEntity := nil.
	browser show: [:a | a tree
		children: [:each :entity | receivedEntity := entity. #()]].
	window := browser openOn: ($a to: $d).
	World doOneCycle.
	self repeatAssert: [receivedEntity] equals: ($a to: $d).
! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: ''!
testTreeAllowDeseletion
	| browser treeNodeMorph |	
	browser := GLMFinder new.
	browser show: [:a | a list allowDeselection].
	window := browser openOn: ($a to: $d).
	treeNodeMorph := self treeRoots first.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value isNil! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: ''!
testTreeDefaultAllowDeseletion
	| browser treeNodeMorph |
	browser := GLMFinder new.
	browser show: [:a | a tree].
	window := browser openOn: ($a to: $d).
	treeNodeMorph := self treeRoots first.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value equals: $a! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: ''!
testTreeMultipleSelection
	| browser treeNodeMorph lastTreeNodeMorph |
	browser := GLMFinder new.
	browser show: [:a | a tree beMultiple].
	window := browser openOn: ($a to: $d).
	treeNodeMorph := self treeRoots first.
	lastTreeNodeMorph := self treeRoots last.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self send: self tree mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self assert: (browser panes first port: #selection) value notNil.
	self assert: (browser panes first port: #selection) value asSet equals: ($a to: $d) asSet! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: ''!
testTreeMultipleSelectionWithCancellation
	| browser treeNodeMorph lastTreeNodeMorph |
	browser := GLMFinder new.
	browser show: [:a | a tree beMultiple allowDeselection].
	window := browser openOn: ($a to: $d).
	treeNodeMorph := self treeRoots first.
	lastTreeNodeMorph := self treeRoots last.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self send: self tree mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value isNil! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: ''!
testTreeSelection
	| browser treeNodeMorph |
	browser := GLMFinder new.
	browser show: [:a | a tree].
	window := browser openOn: ($a to: $d).
	treeNodeMorph := self treeRoots first.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value equals: $a! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: ''!
testTreeSelectionCancellation
	| browser treeNodeMorph |
	browser := GLMFinder new.
	browser show: [:a | a tree allowDeselection].
	window := browser openOn: ($a to: $d).
	treeNodeMorph := self treeRoots first.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self send: self tree mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value isNil! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: ''!
testTreeWithDisplay
	| browser treeCollection |
	treeCollection := { #root1->{#child1->{} . #child2->{}} . #root2 ->{} }.
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a |
		a tree
			display: [:each | each value ];
			children: [:x | x value ] ].
	window := browser openOn: #something -> treeCollection.
	self assert: browser panes first presentations first displayValue == treeCollection! !

!GLMTreeMorphicTest methodsFor: 'tests' stamp: ''!
testTreeWithTags
	"Creates a tree and tag some nodes. Then click on a tag and see if the unmatched nodes disappear"

	| browser model oddNode lineWithNumber3 someNode secondSome |
	model := Dictionary new.
	model at: #some put: #(1 2 3 4).
	model at: #even put: #(2 6 8).
	model at: #odd put: #(3 7 9).
	browser := GLMTabulator new.
	browser column: #one.
	(browser transmit)
		to: #one;
		andShow: [ :a | 
					(a tree)
						display: [ model keys ];
						children: [ :key | 
									key isNumber
										ifFalse: [ model at: key ] ];
						tags: [ :item | 
									item isNumber
										ifTrue: [ 
											item even
												ifTrue: [ #('even') ]
												ifFalse: [ #('odd') ] ]
										ifFalse: [ #() ] ] ].
	window := browser openOn: model.
	World doOneCycle.
	oddNode := self treeRoots second.	
	
	oddNode toggleExpandedState. "Simulate a click on the node's arrow to expand the node and make sub nodes visible"

	World doOneCycle.
	lineWithNumber3 := self treeRoots third.
	(self find: SimpleButtonMorph in: lineWithNumber3) doButtonAction. "Simulate a click on the 'odd' tag to make even numbers disappear"
	
	World doOneCycle.
	someNode := self treeRoots first.
	someNode toggleExpandedState.
	World doOneCycle.
	secondSome := self find: TextMorph in: self treeRoots third.
	self assert: secondSome text asString equals: '3'! !

!GLMTreeMorphicTest methodsFor: 'private' stamp: ''!
tree
	^ self find: MorphTreeMorph in: window! !

!GLMTreeMorphicTest methodsFor: 'private' stamp: ''!
treeRoots
	"Returns the roots of the tree included in the current window. It looks like morphic creates new collections when the tree is refreshed which means different calls to this method may return different objects."
	^ self tree scroller submorphs! !

GLMMorphicTest subclass: #GLMUpdateInterdependentPanesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMUpdateInterdependentPanesTest methodsFor: 'tests' stamp: 'TudorGirba 7/30/2012 07:25'!
testAllowNil
	| browser detailsMorph |
	browser := GLMTabulator new.
	browser
		column: [ :c | 
					c
						row: #one;
						row: #two ];
		column: #details.
	browser
		transmit to: #one;
		andShow: [ :a | a tree display: #(1 2 3) ].
	browser
		transmit to: #two;
		andShow: [ :a | a tree display: #(#a #b #c) ].
	browser
		transmit to: #details;
		from: #one;
		from: #two;
		andShow: [ :a | 
					(a text)
						display: [ :one :two | one asString , two asString ];
						allowNil ].
	window := browser openOn: 42.
	((browser paneNamed: #one) port: #selection) value: 2.
	detailsMorph := window submorphs last submorphs last submorphs first.
	self assert: detailsMorph getText asString equals: '2nil'.
	((browser paneNamed: #two) port: #selection) value: #c.
	detailsMorph := window submorphs last submorphs last submorphs first.
	self assert: detailsMorph getText asString equals: '2c'.
	((browser paneNamed: #one) port: #selection) value: nil.
	detailsMorph := window submorphs last submorphs last submorphs first.
	self assert: detailsMorph getText asString equals: 'nilc'! !

!GLMUpdateInterdependentPanesTest methodsFor: 'tests' stamp: ''!
testInterdependentPanesShouldUpdateTheFocusTriggerPane
	|  treeMorphThree treeMorphThree2 browser treeMorphTwo treeMorphOne |
	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three.
	(browser transmit)
		to: #one;
		andShow: [ :a | a list display: [ :x | 1 to: x ] ].
	(browser transmit)
		to: #two; from: #one;
		andShow: [ :a | a list display: [ :x | 1 to: x * 2 ] ].
	(browser transmit)
		to: #three; from: #two;
		andShow: [ :a | a list display: [ :x | 1 to: x * 3 ] ].
	browser transmit toOutsidePort: #focus; from: #three port: #focus.
	browser transmit to: #one port: #selection; fromOutsidePort: #focus; transformed: [ :x | x + 1 ].
	browser transmit to: #two port: #selection; fromOutsidePort: #focus; transformed: [ :x | x + 2 ].

	window := browser openOn: 5.
	((browser paneNamed: #one) port: #selection) value: 3.
	((browser paneNamed: #two) port: #selection) value: 6.
	treeMorphThree := self findWherePresentationIs: (browser paneNamed: #three) presentations first in: window.

	((browser paneNamed: #three) port: #selection) value: 2.
	((browser paneNamed: #three) port: #focus) value: 1.

	self assert: ((browser paneNamed: #one) port: #entity) value equals: 5.
	self assert: ((browser paneNamed: #one) port: #selection) value equals: 2.
	self assert: ((browser paneNamed: #two) port: #entity) value equals: 2.
	self assert: ((browser paneNamed: #two) port: #selection) value equals: 3.
	self assert: ((browser paneNamed: #three) port: #entity) value equals: 3.
	self assert: ((browser paneNamed: #three) port: #selection) value isNil.

	treeMorphThree2 := self findWherePresentationIs: (browser paneNamed: #three) presentations first in: window.
	self assert: treeMorphThree ~= treeMorphThree2.
	self assert: treeMorphThree2 selectedMorph isNil.

	treeMorphOne := self findWherePresentationIs: (browser paneNamed: #one) presentations first in: window.
	self assert: treeMorphOne selectedMorph notNil.
	
	treeMorphTwo := self findWherePresentationIs: (browser paneNamed: #two) presentations first in: window.
	self assert: treeMorphTwo selectedMorph notNil.
! !

!GLMUpdateInterdependentPanesTest methodsFor: 'tests' stamp: ''!
testInterdependentPanesShouldUpdateTheFocusTriggerPaneWithText
	| browser treeMorphThree treeMorphThree2 |
	browser := GLMTabulator new.
	browser
		column: #one;
		column: #two;
		column: #three.
	(browser transmit)
		to: #one;
		andShow: [ :a | a text display: [ :x | 1 to: x ] ].
	(browser transmit)
		to: #two;
		from: #one;
		andShow: [ :a | a text display: [ :x | 1 to: x * 2 ] ].
	(browser transmit)
		to: #three;
		from: #two;
		andShow: [ :a | a text display: [ :x | 1 to: x * 3 ] ].
	(browser transmit)
		toOutsidePort: #focus;
		from: #three port: #focus.
	(browser transmit)
		to: #one port: #selection;
		fromOutsidePort: #focus;
		transformed: [ :x | x + 1 ].
	(browser transmit)
		to: #two port: #selection;
		fromOutsidePort: #focus;
		transformed: [ :x | x + 2 ].
	window := browser openOn: 5.
	((browser paneNamed: #one) port: #selection) value: 3.
	((browser paneNamed: #two) port: #selection) value: 6.
	treeMorphThree := (window submorphs last submorphs at: 5) submorphs first submorphs first.
	((browser paneNamed: #three) port: #selection) value: 2.
	((browser paneNamed: #three) port: #focus) value: 1.
	self assert: ((browser paneNamed: #one) port: #entity) value equals: 5.
	self assert: ((browser paneNamed: #one) port: #selection) value equals: 2.
	self assert: ((browser paneNamed: #two) port: #entity) value equals: 2.
	self assert: ((browser paneNamed: #two) port: #selection) value equals: 3.
	self assert: ((browser paneNamed: #three) port: #entity) value equals: 3.
	self assert: ((browser paneNamed: #three) port: #selection) value isNil.
	treeMorphThree2 := (window submorphs last submorphs at: 5) submorphs first submorphs first.
	self assert: treeMorphThree ~= treeMorphThree2! !

!GLMUpdateInterdependentPanesTest methodsFor: 'tests' stamp: ''!
testOnePanesShouldUpdateTheRenderedSelectionOnTheTriggerPane

	| browser morphOne |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [:a | a list display: [:x | 1 to: x]].
	browser transmit from: #one port: #strongSelection; toOutsidePort: #toSelect.
	browser transmit fromOutsidePort: #toSelect; to: #one port: #selection; transformed: [:x | x + 1].
	window := browser openOn: 100.
	(browser panes first port: #strongSelection) value: 41.
	self assert: ((browser paneNamed: #one) port: #selection) value equals: 42.
	.
	morphOne := self findWherePresentationIs: (browser paneNamed: #one) presentations first in: window.
	self assert: morphOne notNil.
	self assert: morphOne selectedMorph notNil! !

!GLMUpdateInterdependentPanesTest methodsFor: 'tests' stamp: ''!
testTwoInterdependentPanesShouldUpdateTheRenderedSelectionOnTheTriggerPane

	| browser morphTwo morphOne |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [:a | a list display: [:x | 1 to: x ] ].
	browser transmit from: #one; to: #two; andShow: [:a | a list display: [:x | 1 to: x ] ].
	browser transmit from: #two port: #toSelect; toOutsidePort: #toSelect.
	browser transmit fromOutsidePort: #toSelect; to: #one port: #selection.
	browser transmit fromOutsidePort: #toSelect; to: #two port: #selection.
	window := browser openOn: 100.
	((browser paneNamed: #one) port: #selection) value: 10.
	((browser paneNamed: #two) port: #toSelect) value: 5.
	self assert: ((browser paneNamed: #one) port: #selection) value equals: 5.
	self assert: ((browser paneNamed: #two) port: #selection) value equals: 5.

	World doOneCycle.

	morphOne := self findWherePresentationIs: (browser paneNamed: #one) presentations first in: window.
	self assert: morphOne notNil.
	self assert: morphOne selectedMorph notNil.
	
	morphTwo := self findWherePresentationIs: (browser paneNamed: #two) presentations first in: window.
	self assert: morphTwo notNil.
	self assert: morphTwo selectedMorph notNil! !

GLMMorphicTest subclass: #GLMUpdateMorphicTest
	instanceVariableNames: 'announcer entity browser treeMorph listMorph tableMorph listLabelMorph unupdatedListMorph labelMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: ''!
expectedFailures
	^ #(testUpdatePresentationTitle)! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: ''!
setUp
	announcer := Announcer new.
	entity := OrderedCollection with: 1 with: 2 with: 3.
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [ :a |
		a 
"			title: [:x | x printString ];"
			verticallyStackedArrangement.
		a list 
			title: [:x | x printString ];
			updateOn: TestAnnouncement from: [ announcer ];
			shouldValidate: true.
		a tree 
			title: [:x | x printString ];
			children: #();
			updateOn: TestAnnouncement from: [ announcer ];
			shouldValidate: true.
		a table
			title: [:x | x printString ];
			updateOn: TestAnnouncement from: [ announcer ];
			shouldValidate: true.
		a text 
			updateOn: TestAnnouncement from: [ announcer ].
		a list 
			title: 'Not updated automatically';
			shouldValidate: true.
		a label 
			display: [:x | x isEmpty ifTrue: ['#()'] ifFalse: [x last]];
			updateOn: TestAnnouncement from: [ announcer ].			
			 ].
	browser transmit to: #two; from: #one; andShow: [ :a | a text].
	window := browser openOn: entity.
	listLabelMorph := 			window submorphs last submorphs second submorphs first submorphs 
									first tabSelectorMorph submorphs first submorphs first.
	listMorph := 				window submorphs last submorphs second submorphs first submorphs 
									first submorphs first submorphs first submorphs first.
	treeMorph := 				window submorphs last submorphs second submorphs first submorphs 
									second submorphs first submorphs first submorphs first.
	tableMorph := 				window submorphs last submorphs second submorphs first submorphs 
									third submorphs first submorphs first submorphs first.
	unupdatedListMorph := 	window submorphs last submorphs second submorphs first submorphs 
									fifth submorphs first submorphs first submorphs first.
	labelMorph := 				window submorphs last submorphs second submorphs first submorphs 
									last submorphs first submorphs first.! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: ''!
testAdd
	entity add: 4.
	announcer announce: TestAnnouncement.
	self assert: listMorph roots size = 4.
	self assert: listMorph model roots size equals: 4.
	self assert: treeMorph roots size = 4.
	self assert: treeMorph model roots size equals: 4.
	self assert: tableMorph roots size = 4.
	self assert: tableMorph model roots size equals: 4.
	self assert: labelMorph contents equals: '4'! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: ''!
testAddAndUpdateBrowserManually
	entity add: 4.
	self assert: unupdatedListMorph model roots size equals: 3.
	browser update.
	self assert: unupdatedListMorph model roots size equals: 4.
	entity add: 5.
	browser panes first presentations update.
	self assert: unupdatedListMorph model roots size equals: 5! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: ''!
testAnnouncerUnregistration
	self assert: announcer numberOfSubscriptions = 5.
	browser entity: #($a $b).
	self assert: announcer numberOfSubscriptions = 5.
	browser entity: #($d).
	self assert: announcer numberOfSubscriptions = 5.
	browser entity: #().
	self assert: announcer numberOfSubscriptions = 5.
	browser unregisterFromAllAnnouncements.
	self assert: announcer numberOfSubscriptions = 0! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: ''!
testInvalidateSelection
	(browser panes first port: #selection) value: 3.
	entity removeLast.
	announcer announce: TestAnnouncement.
	self assert: (browser panes first port: #selection) value isNil.
	self assert: listMorph model selection isNil! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: ''!
testRemove
	entity removeLast.
	announcer announce: TestAnnouncement.
	self assert: listMorph model roots size equals: 2.
	self assert: treeMorph model roots size equals: 2.
	self assert: tableMorph model roots size equals: 2.
	self assert: labelMorph contents equals: '2'! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: ''!
testUpdateBrowserTitle
	browser title: 'something'.
	browser update.
	self assert: window label equals: 'something'! !

!GLMUpdateMorphicTest methodsFor: 'tests' stamp: ''!
testUpdatePresentationTitle
	browser panes first presentations first title: 'something'.
	browser panes first presentations first update.
	self assert: listLabelMorph contents equals: 'something'! !

GLMMorphicTest subclass: #GLMWatcherMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMWatcherMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 7/30/2012 07:29'!
expectedFailures 
	^ #(testSimple testWithDynamicPresentation)
! !

!GLMWatcherMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 7/30/2012 07:29'!
testSimple 
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [:a | a list ].
	browser transmit from: #one; toWatcher; andShow: [:a | a text ].
	window := browser openOn: (1 to: 42).
	((browser paneNamed: #one) port: #selection) value: 42.
	(Delay forMilliseconds: 1000) wait.
	self assert: (self find: PluggableTextMorph in: GLMWatcherWindow uniqueInstance) text = '42'! !

!GLMWatcherMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 7/30/2012 07:29'!
testWithDynamicPresentation
	| browser |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [:a | a list ].
	browser transmit from: #one; toWatcher; andShow: [:a | a dynamic display: [:x | GLMTextPresentation new ] ].
	window := browser openOn: (1 to: 42).
	((browser paneNamed: #one) port: #selection) value: 42.
	(Delay forMilliseconds: 1000) wait.

	self assert: (self find: PluggableTextMorph in: GLMWatcherWindow uniqueInstance) text = '42'! !

GLMMorphicTest subclass: #GLMWizardMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMWizardMorphicTest methodsFor: 'tests' stamp: ''!
testClose
	| wizard |
	wizard := GLMWizard new.
	(wizard genericStep: #step) show: [:a | a text ] ; size: 2.
	window := wizard openOn: 123.
	self assert: window owner notNil.
	wizard close.
	self assert: window owner isNil! !

GLMMorphicTest subclass: #GLMWrapperMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMWrapperMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 5/19/2012 08:44'!
testSimple
	| wrapper textMorph |
	wrapper := GLMWrapper new.
	wrapper show: [:a | a text ].
	window := wrapper openOn: 42.
	textMorph := self findWherePresentationIs: wrapper defaultPane presentations first in: window.
	self assert: textMorph text = '42'! !

TestCase subclass: #LazyTabGroupTest
	instanceVariableNames: 'window tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!LazyTabGroupTest methodsFor: 'setup - tear down' stamp: ''!
setUp
	tabs := LazyTabGroupMorph new.
	tabs addLazyPage: (PanelMorph new fillStyle: (SolidFillStyle color: Color red)) label: 'one'.
	tabs addLazyPage: (PanelMorph new fillStyle: (SolidFillStyle color: Color yellow)) label: (LabelMorph contents: 'two').
	window := tabs openInWindow.
! !

!LazyTabGroupTest methodsFor: 'setup - tear down' stamp: ''!
tearDown
	window ifNotNil: [window delete]! !

!LazyTabGroupTest methodsFor: 'tests' stamp: ''!
testIsRendered
	self assert: tabs pages first isRendered not.
	tabs selectedPageIndex: 1.
	self assert: tabs pages first isRendered.
	self assert: tabs pages second isRendered not! !

!LazyTabGroupTest methodsFor: 'tests' stamp: ''!
testPageChangedAnnouncement
	| announcement page |
	announcement := 0.
	tabs announcer
		when: LazyTabPageChanged
		do: [ :ann | 
			announcement := announcement + 1.
			page := ann page ].
	tabs selectedPageIndex: 1.
	self assert: announcement equals: 1.
	self assert: (page isKindOf: LazyTabPage)! !

!LazyTabGroupTest methodsFor: 'tests' stamp: ''!
testPageRemovedAnnouncement
	| announcement |
	announcement := 0.
	tabs announcer when: LazyTabPageRemoved do: [ :ann | announcement := announcement + 1 ].
	tabs announcer when: LazyTabPageChanged do: [ :ann | announcement := announcement + 1 ].
	tabs removePage: tabs pages first.
	self assert: announcement equals: 1! !

!LazyTabGroupTest methodsFor: 'tests' stamp: ''!
testRemoveAllPages
	tabs removePage: tabs pages first.
	tabs removePage: tabs pages first.
	self assert: tabs pages isEmpty.
	self assert: tabs contentMorph submorphs isEmpty! !

!LazyTabGroupTest methodsFor: 'tests' stamp: ''!
testRemovePage
	tabs removePage: tabs pages first.
	self assert: tabs pages size equals: 1! !

!LazyTabGroupTest methodsFor: 'tests' stamp: ''!
testSimpleCreation
	self assert: tabs pages size equals: 2! !
